<template>
  <AppMainCard
    text-root="verify"
    :type="type"
  >
    <div
      class="w-full md:w-3/4"
    >
      <VerificationSteps
        v-if="isValidating"
        :is-credential-valid="isCredentialValid"
      />
      <div
        v-else
        class="max-w-[20rem] m-auto"
      >
        <AppFlexCenterLayout column>
          <h1 class="mb-5 text-3xl font-black">
            {{ $t('requestCredentials.stepOneSubTitle') }}
          </h1>
        </AppFlexCenterLayout>
        <SSIFormSelection
          v-model="ssiWallet"
          :loading="loading"
          @click="verifyCredentials"
        />
      </div>
    </div>
  </AppMainCard>
</template>

<script lang="ts">
import Vue from 'vue'
import { AlertType } from '~/utility/constant'

export default Vue.extend({
  name: 'VerificationPage',
  data() {
    return {
      loading: false,
      isChecking: true,
      successStepOne: false,
      successStepTwo: false,
      isCredentialValid: false,
      isValidating: false,
      fail: false,
      ssiWallet: ''
    }
  },
  computed: {
    type() {
      if (this.successStepOne) { return AlertType.SUCCESS }
      if (this.fail) { return AlertType.ERROR }
      return AlertType.DEFAULT
    }
  },
  created() {
    const { accessToken } = this.$route.query

    if (!accessToken) {
      return
    }

    this.isValidating = true
    const baseURI = 'https://wallet.lab.gaia-x.eu/verifier-api'

    fetch(`${baseURI}/auth?accessToken=${accessToken}`)
      .then(response => response.json())
      .then(data => {
        const requestOptions = {
          method: 'GET',
          Authorization: `Bearer ${data.auth_token}`

        }

        fetch(`${baseURI}/protected`, requestOptions)
          .then(response => response.json())
          .then(_result => {
            this.successStepOne = true
            this.isCredentialValid = _result
          })
      })
      .catch(err => {
        // eslint-disable-next-line no-console
        console.error(err)
      })
  },
  methods: {
    verifyCredentials() {
      const baseURI = 'https://wallet.lab.gaia-x.eu/verifier-api'
      const schemaUri = 'https://raw.githubusercontent.com/walt-id/waltid-ssikit-vclib/master/src/test/resources/schemas/ParticipantCredential.json'
      const url = `${baseURI}/present?walletId=walt.id&schemaUri=${schemaUri}`
      window.open(url)
    }
  }
})
</script>

<style scoped>

</style>
